#include "brick.h"
#include "opengl.h"
#include "drawing.h"
#include <stdio.h>
#include <cstdlib>
#include "musicmixer.h"

Brick::Brick()
{
    this->position = pos(.0, -.5, 0);
    int acc = OpenGL::Instance()->getLevel();
    if(acc > 60)
        acc = 60;
    this->velocity = vec(.0, .007 + acc*.0005, .0);
    for(int i=0; i<3; i++)
        this->color[i] = float(rand()%256)/256.;
    this->marked = false;
}

Brick::~Brick()
{
}

void Brick::draw()
{
    OpenGL * game = OpenGL::Instance();
    glScaled(4, .8, 1);
    if(this->marked){
        game->bindTexture("right");
        Drawing::setMaterial(1., 1., 1.);
        Drawing::drawBox(.1, 1.);
        glDisable(GL_TEXTURE_2D);
    }else{
        Drawing::setMaterial(.5, .4, .1);
        Drawing::setMaterial(this->color[0], this->color[1], this->color[2]);
        Drawing::drawBox(.1);
    }
}

void Brick::move()
{
    Object::move();
    rect r = this->getRect();
    rect cr = OpenGL::Instance()->getRect();
    if(r.bottom > cr.top)
        this->dispose();
}

rect Brick::getRect()
{
    rect r;
    r.left = this->position.x() - .2;
    r.right = this->position.x() + .2;
    r.top = this->position.y() + .04;
    r.bottom = this->position.y() - .04;
    return r;
}

void Brick::mark()
{
    if(!this->marked){
        this->marked = true;
        MusicMixer::Instance()->playSample("resource/step.wav");
    }
}

