#include "object.h"
#include "drawing.h"

Object::Object()
{
    this->position = pos(0, 0, 0);
    this->velocity = vec(0, 0, 0);
    this->disposed = false;
}

Object::~Object()
{
}

void Object::draw()
{
    Drawing::setMaterial(.6, .2, .6);
    Drawing::drawBox(.5);
}

void Object::hide()
{
    this->visible = false;
}

bool Object::isVisible() const
{
    return this->visible;
}

void Object::move()
{
    this->position += this->velocity;
}

void Object::show()
{
    this->visible = true;
}

rect Object::getRect()
{
    return rect(0., 0., 0., 0.);
}

void Object::dispose()
{
    this->disposed = true;
}

bool Object::isDisposed() const
{
    return this->disposed;
}

