#ifndef _TEXTURE_H_
#define _TEXTURE_H_

#include <GL/glut.h>
#include <string>
#include "bmp.h"
#include <cstdio>
using namespace std;

struct Texture
{
    unsigned char* buffer;
    int width, height;
    GLuint textureId;
    
    Texture(string file){
        buffer = loadBMP(file.c_str(), width, height);

        if(buffer == 0){
            fprintf(stderr, "failed to read bitmap file: %s\n", file.c_str());
            exit(1);
        }
        
        glGenTextures(1, &textureId);
        glBindTexture(GL_TEXTURE_2D, textureId);
        glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
        glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
        glTexImage2D(GL_TEXTURE_2D, 0, 3, width, height, 0, GL_RGB, GL_UNSIGNED_BYTE, buffer);
        free(buffer);
    }
    
    void bind(){
        glEnable(GL_TEXTURE_2D);
        glBindTexture(GL_TEXTURE_2D, textureId);
    }
};

#endif //_TEXTURE_H_
